'+--------------------------------------------------------------------------+
'|                                ZoomPlus                                  |
'|                                                                          |
'|         Load large image using the GDImage zoom control feature.         |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                                                                          |
'|                           copyright (c) 2007                             |
'|                                                                          |
'|                Patrice Terrier http://www.zapsolution.com                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 08-07-2006 (MM-DD-YYYY)            |
'|                        Last revised : 04-11-2007 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "ZoomPlus.exe"

'-----------------------------------------------------------------
' Equates:  136
'-----------------------------------------------------------------
%CF_BITMAP                                      = 2
%WINAPI                                         = 1
%TRUE                                           = 1
%FALSE                                          = 0
%NULL                                           = 0
%WM_USER                                        = &H400
%LF_FACESIZE                                    = 32
%ERROR_ALREADY_EXISTS                           = 183
%HEAP_ZERO_MEMORY                               = &H00000008
%LR_LOADFROMFILE                                = &H0010
%DFC_BUTTON                                     = 4
%DFCS_BUTTONPUSH                                = &H0010
%DFCS_HOT                                       = &H00001000
%DFCS_FLAT                                      = &H00004000
%MAX_PATH                                       = 260  ' max. length of full pathname
%OUT_DEFAULT_PRECIS                             = 0
%DEFAULT_QUALITY                                = 0
%DEFAULT_PITCH                                  = 0
%DEFAULT_CHARSET                                = 1
%FF_DONTCARE                                    = 0    ' Don't care or don't know.
%TRANSPARENT                                    = 1
%NULL_BRUSH                                     = 5
%ANSI_VAR_FONT                                  = 12
%BDR_RAISEDOUTER                                = &H0001
%BDR_SUNKENOUTER                                = &H0002
%BDR_RAISEDINNER                                = &H0004
%BDR_SUNKENINNER                                = &H0008
%EDGE_RAISED                                    = %BDR_RAISEDOUTER OR %BDR_RAISEDINNER
%EDGE_SUNKEN                                    = %BDR_SUNKENOUTER OR %BDR_SUNKENINNER
%BF_LEFT                                        = &H0001
%BF_TOP                                         = &H0002
%BF_RIGHT                                       = &H0004
%BF_BOTTOM                                      = &H0008
%BF_RECT                                        = %BF_LEFT OR %BF_TOP OR %BF_RIGHT OR %BF_BOTTOM
%BF_MIDDLE                                      = &H00000800  '* Fill in the middle
%BF_SOFT                                        = &H00001000  '* For softer buttons
%BF_FLAT                                        = &H00004000  '* For flat rather than 3D borders
%SW_RESTORE                                     = 9
%VK_RETURN                                      = &H0D
%VK_SPACE                                       = &H20
%GWL_STYLE                                      = -16
%WM_CREATE                                      = &H1
%WM_DESTROY                                     = &H2
%WM_SIZE                                        = &H5
%WM_SETFOCUS                                    = &H7
%WM_KILLFOCUS                                   = &H8
%WM_ENABLE                                      = &HA
%WM_PAINT                                       = &HF
%WM_CLOSE                                       = &H10
%WM_ERASEBKGND                                  = &H14
%WM_SETCURSOR                                   = &H20
%WM_GETMINMAXINFO                               = &H24
%WM_SETFONT                                     = &H30
%WM_NOTIFY                                      = &H4E
%WM_GETDLGCODE                                  = &H087
%WM_KEYDOWN                                     = &H100
%WM_KEYUP                                       = &H101
%WM_CHAR                                        = &H102
%WM_COMMAND                                     = &H111
%WM_TIMER                                       = &H113
%WM_CTLCOLORSTATIC                              = &H138
%WM_MOUSEMOVE                                   = &H200
%WM_LBUTTONDOWN                                 = &H201
%WM_LBUTTONUP                                   = &H202
%WM_LBUTTONDBLCLK                               = &H203
%WM_RBUTTONDOWN                                 = &H204
%WM_MOVING                                      = &H216
%WM_MOUSELEAVE                                  = &H2A3
%WM_VSCROLL                                     = &H115
%SIZE_MINIMIZED                                 = 1
%TME_LEAVE                                      = &H00000002
%WS_OVERLAPPED                                  = &H0
%WS_POPUP                                       = &H80000000
%WS_CHILD                                       = &H40000000
%WS_VISIBLE                                     = &H10000000
%WS_CLIPSIBLINGS                                = &H04000000
%WS_CLIPCHILDREN                                = &H02000000
%WS_CAPTION                                     = &H00C00000  ' WS_BORDER OR WS_DLGFRAME
%WS_VSCROLL                                     = &H00200000
%WS_HSCROLL                                     = &H00100000
%WS_SYSMENU                                     = &H00080000
%WS_EX_TOOLWINDOW                               = &H00000080
%WS_THICKFRAME                                  = &H00040000
%WS_BORDER                                      = &H00800000
%WS_GROUP                                       = &H00020000
%WS_TABSTOP                                     = &H00010000
%WS_MINIMIZEBOX                                 = &H00020000
%WS_MAXIMIZEBOX                                 = &H00010000
%WS_OVERLAPPEDWINDOW                            = %WS_OVERLAPPED OR %WS_CAPTION OR %WS_SYSMENU OR %WS_THICKFRAME OR %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX
%WS_EX_TRANSPARENT                              = &H00000020
%WS_EX_WINDOWEDGE                               = &H00000100
%WS_EX_STATICEDGE                               = &H00020000
%WS_EX_APPWINDOW                                = &H00040000
%CS_VREDRAW                                     = &H1
%CS_HREDRAW                                     = &H2
%CS_DBLCLKS                                     = &H8
%CS_PUBLICCLASS                                 = &H00004000
%CS_GLOBALCLASS                                 = %CS_PUBLICCLASS
%PM_REMOVE                                      = &H0001
%CW_USEDEFAULT                                  = &H80000000&
%SM_CXSCREEN                                    = 0
%SM_CYSCREEN                                    = 1
%DT_LEFT                                        = &H0
%DT_CENTER                                      = &H1
%DT_RIGHT                                       = &H2
%DT_VCENTER                                     = &H4
%DT_SINGLELINE                                  = &H20
%DST_BITMAP                                     = &H00000004???
%COLOR_WINDOWTEXT                               = 8
%COLOR_BTNFACE                                  = 15
%COLOR_BTNSHADOW                                = 16
%COLOR_BTNTEXT                                  = 18
%COLOR_BTNHIGHLIGHT                             = 20
%COLOR_INFOTEXT                                 = 23
%COLOR_INFOBK                                   = 24
%COLOR_3DSHADOW                                 = %COLOR_BTNSHADOW
%COLOR_3DHILIGHT                                = %COLOR_BTNHIGHLIGHT
%IDC_ARROW                                      = 32512&
%IDC_WAIT                                       = 32514&
%BS_GROUPBOX                                    = &H7&
%BS_FLAT                                        = &H00008000&
%BN_CLICKED                                     = 0
%BST_PUSHED                                     = &H04
%SS_CENTER                                      = &H00000001
%SS_SUNKEN                                      = &H00001000
%DLGC_WANTALLKEYS                               = &H4    ' Control wants all keys
%DLGC_UNDEFPUSHBUTTON                           = &H20   ' Non-default pushbutton
%DLGC_BUTTON                                    = &H2000 ' Button item: can be checked
%DI_NORMAL                                      = &H0003
%IMAGE_BITMAP                                   = 0
%IMAGE_ICON                                     = 1
%TTS_ALWAYSTIP                                  = &H0001
%TTF_IDISHWND                                   = &H00000001
%TTF_SUBCLASS                                   = &H00000010
%TTM_ADDTOOL                                    = %WM_USER +  4
%TTM_UPDATETIPTEXT                              = %WM_USER + 12
%TTM_SETTIPBKCOLOR                              = %WM_USER + 19
%TTM_SETTIPTEXTCOLOR                            = %WM_USER + 20
%TTM_SETMAXTIPWIDTH                             = %WM_USER + 24
%SBARS_SIZEGRIP                                 = &H0100
%SBARS_TOOLTIPS                                 = &H0800
%TBS_VERT                                       = &H0002
%TBS_BOTH                                       = &H0008
%TBS_NOTICKS                                    = &H0010
%TBM_GETPOS                                     = %WM_USER
%TBM_SETPOS                                     = %WM_USER + 5
%TBM_SETRANGE                                   = %WM_USER + 6
%TBM_SETPAGESIZE                                = %WM_USER + 21

%SB_LINEUP        = 0
%SB_LINEDOWN      = 1
%SB_PAGEUP        = 2
%SB_PAGEDOWN      = 3
%SB_THUMBPOSITION = 4
%SB_THUMBTRACK    = 5
%SB_TOP           = 6
%SB_BOTTOM        = 7
%SB_ENDSCROLL     = 8

'-----------------------------------------------------------------
' TYPE and UNION structures:  11
'-----------------------------------------------------------------
TYPE RECT
  nLeft AS LONG
  nTop AS LONG
  nRight AS LONG
  nBottom AS LONG
END TYPE

TYPE TRACKMOUSEEVENTAPI
    cbSize AS DWORD
    dwFlags AS DWORD
    hwndTrack AS DWORD
    dwHoverTime AS DWORD
END TYPE

TYPE POINTAPI
  x AS LONG
  y AS LONG
END TYPE

TYPE POINTS
  x AS INTEGER
  y AS INTEGER
END TYPE

TYPE tagMSG
  hwnd AS DWORD
  message AS DWORD
  wParam AS LONG
  lParam AS LONG
  time AS DWORD
  pt AS POINTAPI
END TYPE

TYPE SECURITY_ATTRIBUTES
  nLength AS DWORD
  lpSecurityDescriptor AS LONG
  bInheritHandle AS LONG
END TYPE

TYPE WNDCLASSEX
    cbSize AS DWORD
    STYLE AS DWORD
    lpfnWndProc AS LONG
    cbClsExtra AS LONG
    cbWndExtra AS LONG
    hInstance AS DWORD
    hIcon AS DWORD
    hCursor AS DWORD
    hbrBackground AS DWORD
    lpszMenuName AS ASCIIZ PTR
    lpszClassName AS ASCIIZ PTR
    hIconSm AS DWORD
END TYPE

TYPE LOGFONT
  lfHeight AS LONG
  lfWidth AS LONG
  lfEscapement AS LONG
  lfOrientation AS LONG
  lfWeight AS LONG
  lfItalic AS BYTE
  lfUnderline AS BYTE
  lfStrikeOut AS BYTE
  lfCharSet AS BYTE
  lfOutPrecision AS BYTE
  lfClipPrecision AS BYTE
  lfQuality AS BYTE
  lfPitchAndFamily AS BYTE
  lfFaceName AS ASCIIZ * %LF_FACESIZE
END TYPE

TYPE MINMAXINFO
    ptReserved AS POINTAPI
    ptMaxSize AS POINTAPI
    ptMaxPosition AS POINTAPI
    ptMinTrackSize AS POINTAPI
    ptMaxTrackSize AS POINTAPI
END TYPE

TYPE PAINTSTRUCT
  hDC AS DWORD
  fErase AS LONG
  rcPaint AS RECT
  fRestore AS LONG
  fIncUpdate AS LONG
  rgbReserved(0 TO 31) AS BYTE
END TYPE

TYPE TOOLINFO
  cbSize AS DWORD
  uFlags AS DWORD
  hwnd AS DWORD
  uId AS DWORD
  rec AS RECT
  hinst AS DWORD
  lpszText AS ASCIIZ PTR
  lParam AS LONG
  lpReserved AS DWORD
END TYPE

'-----------------------------------------------------------------
' Declared Functions:  75
'-----------------------------------------------------------------
DECLARE FUNCTION GetTickCount LIB "KERNEL32.DLL" ALIAS "GetTickCount" () AS DWORD
DECLARE FUNCTION OpenClipboard LIB "USER32.DLL" ALIAS "OpenClipboard" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION SetClipboardData LIB "USER32.DLL" ALIAS "SetClipboardData" (BYVAL dwFormat AS DWORD, BYVAL hMem AS DWORD) AS DWORD
DECLARE FUNCTION EmptyClipboard LIB "USER32.DLL" ALIAS "EmptyClipboard" () AS LONG
DECLARE FUNCTION CloseClipboard LIB "USER32.DLL" ALIAS "CloseClipboard" () AS LONG
DECLARE FUNCTION AdjustWindowRectEx LIB "USER32.DLL" ALIAS "AdjustWindowRectEx" (lpRect AS RECT, BYVAL dsStyle AS LONG, BYVAL bMenu AS LONG, BYVAL dwEsStyle AS DWORD) AS LONG
DECLARE FUNCTION BeginPaint LIB "USER32.DLL" ALIAS "BeginPaint" (BYVAL hWnd AS DWORD, lpPaint AS PAINTSTRUCT) AS LONG
DECLARE FUNCTION CloseHandle LIB "KERNEL32.DLL" ALIAS "CloseHandle" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION CreateFontIndirect LIB "GDI32.DLL" ALIAS "CreateFontIndirectA" (lpLogFont AS LOGFONT) AS DWORD
DECLARE FUNCTION CreateMutex LIB "KERNEL32.DLL" ALIAS "CreateMutexA" (lpMutexAttributes AS SECURITY_ATTRIBUTES, BYVAL bInitialOwner AS LONG, lpName AS ASCIIZ) AS LONG
DECLARE FUNCTION CreateWindowEx LIB "USER32.DLL" ALIAS "CreateWindowExA" (BYVAL dwExStyle AS DWORD, lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, _
    BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hWndParent AS DWORD, BYVAL hMenu AS DWORD, BYVAL hInstance AS DWORD, lpParam AS ANY) AS DWORD
DECLARE FUNCTION DefWindowProc LIB "USER32.DLL" ALIAS "DefWindowProcA" (BYVAL hWnd AS DWORD, BYVAL uMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION DeleteObject LIB "GDI32.DLL" ALIAS "DeleteObject" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION DispatchMessage LIB "USER32.DLL" ALIAS "DispatchMessageA" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION DrawEdge LIB "USER32.DLL" ALIAS "DrawEdge" (BYVAL hDC AS DWORD, qrc AS RECT, BYVAL edge AS LONG, BYVAL grfFlags AS LONG) AS LONG
DECLARE FUNCTION DrawFocusRect LIB "USER32.DLL" ALIAS "DrawFocusRect" (BYVAL hDC AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION DrawFrameControl LIB "USER32.DLL" ALIAS "DrawFrameControl" (BYVAL hDC AS DWORD, lpRect AS RECT, BYVAL un1 AS LONG, BYVAL un2 AS LONG) AS LONG
DECLARE FUNCTION DrawIconEx LIB "USER32.DLL" ALIAS "DrawIconEx" (BYVAL hDC AS DWORD, BYVAL xLeft AS LONG, BYVAL yTop AS LONG, BYVAL hIcon AS DWORD, BYVAL cxWidth AS LONG, BYVAL cyWidth AS LONG, BYVAL istepIfAniCur AS LONG, _
                 BYVAL hbrFlickerFreeDraw AS DWORD, BYVAL diFlags AS LONG) AS LONG
DECLARE FUNCTION DrawState LIB "USER32.DLL" ALIAS "DrawStateA" (BYVAL hDC AS DWORD, BYVAL hBrush AS DWORD, BYVAL lpDrawStateProc AS DWORD, BYVAL lParam AS LONG, BYVAL wParam AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL cx AS LONG, _
                 BYVAL cy AS LONG, BYVAL fuFlags AS DWORD) AS LONG
DECLARE FUNCTION DrawText LIB "USER32.DLL" ALIAS "DrawTextA" (BYVAL hDC AS DWORD, lpStr AS ASCIIZ, BYVAL nCount AS LONG, lpRect AS RECT, BYVAL uFormat AS DWORD) AS LONG
DECLARE FUNCTION EndPaint LIB "USER32.DLL" ALIAS "EndPaint" (BYVAL hWnd AS DWORD, lpPaint AS PAINTSTRUCT) AS LONG
DECLARE FUNCTION FillRect LIB "USER32.DLL" ALIAS "FillRect" (BYVAL hDC AS DWORD, lpRect AS RECT, BYVAL hBrush AS DWORD) AS LONG
DECLARE FUNCTION FindWindow LIB "USER32.DLL" ALIAS "FindWindowA" (lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ) AS LONG
DECLARE FUNCTION FrameRect LIB "USER32.DLL" ALIAS "FrameRect" (BYVAL hDC AS DWORD, lpRect AS RECT, BYVAL hBrush AS DWORD) AS LONG
DECLARE FUNCTION FreeLibrary LIB "KERNEL32.DLL" ALIAS "FreeLibrary" (BYVAL hLibModule AS DWORD) AS LONG
DECLARE FUNCTION GetClassInfoEx LIB "USER32.DLL" ALIAS "GetClassInfoExA" (BYVAL hInst AS DWORD, lpszClass AS ASCIIZ, lpWndClass AS WNDCLASSEX) AS LONG
DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetCursorPos LIB "USER32.DLL" ALIAS "GetCursorPos" (lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION GetDlgCtrlID LIB "USER32.DLL" ALIAS "GetDlgCtrlID" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" (BYVAL hDlg AS DWORD, BYVAL nIDDlgItem AS LONG) AS DWORD
DECLARE FUNCTION GetFocus LIB "USER32.DLL" ALIAS "GetFocus" () AS DWORD
DECLARE FUNCTION GetLastError LIB "KERNEL32.DLL" ALIAS "GetLastError" () AS LONG
DECLARE FUNCTION GetMessage LIB "USER32.DLL" ALIAS "GetMessageA" (lpMsg AS tagMSG, BYVAL hWnd AS DWORD, BYVAL uMsgFilterMin AS DWORD, BYVAL uMsgFilterMax AS DWORD) AS LONG
DECLARE FUNCTION GetModuleHandle LIB "KERNEL32.DLL" ALIAS "GetModuleHandleA" (lpModuleName AS ASCIIZ) AS DWORD
DECLARE FUNCTION GetParent LIB "USER32.DLL" ALIAS "GetParent" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION GetProcAddress LIB "KERNEL32.DLL" ALIAS "GetProcAddress" (BYVAL hModule AS DWORD, lpProcName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetProcessHeap LIB "KERNEL32.DLL" ALIAS "GetProcessHeap" () AS LONG
DECLARE FUNCTION GetProp LIB "USER32.DLL" ALIAS "GetPropA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION GetStockObject LIB "GDI32.DLL" ALIAS "GetStockObject" (BYVAL nIndex AS LONG) AS DWORD
DECLARE FUNCTION GetSysColor LIB "USER32.DLL" ALIAS "GetSysColor" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetSysColorBrush LIB "USER32.DLL" ALIAS "GetSysColorBrush" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetSystemMetrics LIB "USER32.DLL" ALIAS "GetSystemMetrics" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetWindowLong LIB "USER32.DLL" ALIAS "GetWindowLongA" (BYVAL hWnd AS DWORD, BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetWindowRect LIB "USER32.DLL" ALIAS "GetWindowRect" (BYVAL hWnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetWindowText LIB "USER32.DLL" ALIAS "GetWindowTextA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ, BYVAL cch AS LONG) AS LONG
DECLARE FUNCTION HeapAlloc LIB "KERNEL32.DLL" ALIAS "HeapAlloc" (BYVAL hHeap AS DWORD, BYVAL dwFlags AS DWORD, BYVAL dwBytes AS DWORD) AS DWORD
DECLARE FUNCTION HeapFree LIB "KERNEL32.DLL" ALIAS "HeapFree" (BYVAL hHeap AS DWORD, BYVAL dwFlags AS DWORD, BYVAL lpMem AS DWORD) AS LONG
DECLARE FUNCTION InflateRect LIB "USER32.DLL" ALIAS "InflateRect" (lpRect AS RECT, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE FUNCTION InvalidateRect LIB "USER32.DLL" ALIAS "InvalidateRect" (BYVAL hWnd AS DWORD, lpRect AS RECT, BYVAL bErase AS LONG) AS LONG
DECLARE FUNCTION IsDialogMessage LIB "USER32.DLL" ALIAS "IsDialogMessageA" (BYVAL hDlg AS DWORD, lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION IsIconic LIB "USER32.DLL" ALIAS "IsIconic" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION IsWindowEnabled LIB "USER32.DLL" ALIAS "IsWindowEnabled" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION IsWindowVisible LIB "USER32.DLL" ALIAS "IsWindowVisible" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION LoadCursor LIB "USER32.DLL" ALIAS "LoadCursorA" (BYVAL hInstance AS DWORD, lpCursorName AS ASCIIZ) AS DWORD
DECLARE FUNCTION LoadIcon LIB "USER32.DLL" ALIAS "LoadIconA" (BYVAL hInstance AS DWORD, lpIconName AS ASCIIZ) AS DWORD
DECLARE FUNCTION LoadImage LIB "USER32.DLL" ALIAS "LoadImageA" (BYVAL hInst AS DWORD, lpsz AS ASCIIZ, BYVAL uType AS DWORD, BYVAL cxDesired AS LONG, BYVAL cyDesired AS LONG, BYVAL fuLoad AS DWORD) AS DWORD
DECLARE FUNCTION LoadLibrary LIB "KERNEL32.DLL" ALIAS "LoadLibraryA" (lpLibFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION OffsetRect LIB "USER32.DLL" ALIAS "OffsetRect" (lpRect AS RECT, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE FUNCTION PeekMessage LIB "USER32.DLL" ALIAS "PeekMessageA" (lpMsg AS tagMSG, BYVAL hWnd AS DWORD, BYVAL dwMsgFilterMin AS DWORD, BYVAL dwMsgFilterMax AS DWORD, BYVAL dwRemoveMsg AS DWORD) AS LONG
DECLARE FUNCTION PtInRect LIB "USER32.DLL" ALIAS "PtInRect" (lpRect AS RECT, BYVAL ptx AS LONG, BYVAL pty AS LONG) AS LONG
DECLARE FUNCTION RegisterClassEx LIB "USER32.DLL" ALIAS "RegisterClassExA" (pcWndClassEx AS WNDCLASSEX) AS WORD
DECLARE FUNCTION ReleaseCapture LIB "USER32.DLL" ALIAS "ReleaseCapture" () AS LONG
DECLARE FUNCTION RemoveProp LIB "USER32.DLL" ALIAS "RemovePropA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION SelectObject LIB "GDI32.DLL" ALIAS "SelectObject" (BYVAL hdc AS DWORD, BYVAL hObject AS DWORD) AS DWORD
DECLARE FUNCTION SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SetBkColor LIB "GDI32.DLL" ALIAS "SetBkColor" (BYVAL hdc AS DWORD, BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION SetBkMode LIB "GDI32.DLL" ALIAS "SetBkMode" (BYVAL hdc AS DWORD, BYVAL nBkMode AS LONG) AS LONG
DECLARE FUNCTION SetCapture LIB "USER32.DLL" ALIAS "SetCapture" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION SetCursor LIB "USER32.DLL" ALIAS "SetCursor" (BYVAL hCursor AS DWORD) AS DWORD
DECLARE FUNCTION SetFocus LIB "USER32.DLL" ALIAS "SetFocus" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION SetForegroundWindow LIB "USER32.DLL" ALIAS "SetForegroundWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION SetProp LIB "USER32.DLL" ALIAS "SetPropA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ, BYVAL hData AS DWORD) AS LONG
DECLARE FUNCTION SetRect LIB "USER32.DLL" ALIAS "SetRect" (lpRect AS RECT, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION SetTextColor LIB "GDI32.DLL" ALIAS "SetTextColor" (BYVAL hdc AS DWORD, BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION SetWindowLong LIB "USER32.DLL" ALIAS "SetWindowLongA" (BYVAL hWnd AS DWORD, BYVAL nIndex AS LONG, BYVAL lNewLong AS LONG) AS LONG
DECLARE FUNCTION SetWindowText LIB "USER32.DLL" ALIAS "SetWindowTextA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION ShowWindow LIB "USER32.DLL" ALIAS "ShowWindow" (BYVAL hWnd AS DWORD, BYVAL nCmdShow AS LONG) AS LONG
DECLARE FUNCTION TrackMouseEvent LIB "USER32.DLL" ALIAS "TrackMouseEvent" (lpEventTrack AS TRACKMOUSEEVENTAPI) AS LONG
DECLARE FUNCTION TranslateMessage LIB "USER32.DLL" ALIAS "TranslateMessage" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION UpdateWindow LIB "USER32.DLL" ALIAS "UpdateWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION PostMessage LIB "USER32.DLL" ALIAS "PostMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG

'-----------------------------------------------------------------
' Declared Subs:  2
'-----------------------------------------------------------------
DECLARE SUB InitCommonControls LIB "COMCTL32.DLL" ALIAS "InitCommonControls" ()
DECLARE SUB PostQuitMessage LIB "USER32.DLL" ALIAS "PostQuitMessage" (BYVAL nExitCode AS LONG)

DECLARE SUB OUTPUTDEBUGSTRING LIB "KERNEL32.DLL" ALIAS "OutputDebugStringA" (lpOutputString AS ASCIIZ)

MACRO DP(TextOutput)
  CALL OUTPUTDEBUGSTRING (BYCOPY TextOutput)
END MACRO

'------------------------------------------------------------------------------------------
#RESOURCE "zoomplus.pbr"
'------------------------------------------------------------------------------------------
#INCLUDE "gdimage.inc"
#INCLUDE "TB_XPBUTTON.INC" ' Thanks to Jos Roca for this great piece of code
'------------------------------------------------------------------------------------------

%ID_STATUSBAR       = 100
%ID_CTRL            = 101
%ID_THUMBCTRL       = 102
%ID_BTN_FlipX       = 103
%ID_BTN_Save        = 104
%ID_BTN_FlipY       = 105
%ID_BTN_RotateLeft  = 106
%ID_BTN_LoadImage   = 107
%ID_BTN_RotateRight = 108
%ID_BTN_CROP        = 109
%ID_STA_Help        = 110
%ID_GRP_Help        = 111
%ID_ZOOM            = 112
%ID_STATIC          = 113

%COLORGRAY = &HC0C0C0

$FirstPicture = "zoomplus.gif"

' WinXP Theme support declares (if applicable)
DECLARE FUNCTION EnableDialogTheme(BYVAL hDlg AS DWORD, BYVAL dwStyle AS DWORD) AS LONG
DECLARE FUNCTION IsThemeActive() AS LONG

GLOBAL ghRegion AS LONG, ghLayered AS LONG

FUNCTION zDefaultFont() AS LONG
    STATIC hDefault&
    IF hDefault& = 0 THEN hDefault& = GetStockObject(%ANSI_VAR_FONT)
    FUNCTION = hDefault&
END FUNCTION

SUB zSetCTLFont(BYVAL hCTRL&, BYVAL hFont&)
    CALL SendMessage(hCTRL&, %WM_SETFONT, hFont&, 0)
END SUB

FUNCTION zCaptionFont() AS LONG
    DIM LF AS LogFont
    STATIC CaptionFont&
    IF CaptionFont& = 0 THEN
       LF.lfHeight = 8 ' -FontHeight&
       LF.lfWidth = 0
       LF.lfCharSet = %DEFAULT_CHARSET
       LF.lfOutPrecision = %OUT_DEFAULT_PRECIS
       LF.lfClipPrecision = %OUT_DEFAULT_PRECIS
       LF.lfQuality = %DEFAULT_QUALITY
       LF.lfPitchAndFamily = %DEFAULT_PITCH OR %FF_DONTCARE
       LF.lfWeight = 700
       LF.lfFaceName = "MS Sans Serif"
       CaptionFont& = CreateFontIndirect(LF)
    END IF
    FUNCTION = CaptionFont&
END FUNCTION

' Safely delete a zc object
SUB zDeleteObject(hObject&)
    IF hObject& THEN
       CALL DeleteObject(hObject&): hObject& = 0
    END IF
END SUB

FUNCTION ToolTipData(BYVAL hTooltip&, BYVAL RW&) AS LONG
    STATIC WasTooltip&
    IF RW& THEN WasTooltip& = hTooltip&
    FUNCTION = WasTooltip&
END FUNCTION

FUNCTION zToolTip(BYVAL hObj&, BYVAL Text$) AS LONG

    LOCAL ti AS TOOLINFO

    hTooltip& = ToolTipData(0, 0)
    IF hTooltip& = 0 THEN
       CALL InitCommonControls()
       StyleEx& = 0 ' %WS_EX_TOPMOST ' Instead of 0 to use it with skMsgBox buttons
       hTooltip& = CreateWindowEx(StyleEx&, _
                             "tooltips_class32", _
                             BYVAL %NULL, _
                             %WS_POPUP OR %TTS_ALWAYSTIP, _
                             %CW_USEDEFAULT, _
                             %CW_USEDEFAULT, _
                             %CW_USEDEFAULT, _
                             %CW_USEDEFAULT, _
                             GetParent(hObj&), _
                             0, _
                             zInstance, _ 'hinst
                             BYVAL 0)
       IF hTooltip& THEN
          CALL ToolTipData(hTooltip&, 1)
          CALL SendMessage(hTooltip&, %TTM_SETTIPTEXTCOLOR, GetSysColor(%COLOR_INFOTEXT), 0)
          CALL SendMessage(hTooltip&, %TTM_SETTIPBKCOLOR, GetSysColor(%COLOR_INFOBK), 0)
          CALL SendMessage(hTooltip&, %TTM_SETMAXTIPWIDTH, 0, 400)
       END IF
    END IF
    IF hTooltip& THEN
       ti.cbSize   = sizeof(ti)
       ti.hinst    = zInstance
       ti.uFlags   = %TTF_IDISHWND OR %TTF_SUBCLASS
       ti.hWnd     = GetParent(hObj&)
       ti.uId      = hObj&
     ' Add tooltip now.
       CALL SendMessage(hTooltip&, %TTM_ADDTOOL, 0, BYVAL VARPTR(ti))
       CALL zSetToolTipText(hObj&, Text$)
    END IF
    FUNCTION = hTooltip&
END FUNCTION

SUB zSetToolTipText(BYVAL hObj&, BYVAL Text$)
    LOCAL ti AS TOOLINFO
    LOCAL zLabel AS ASCIIZ * 256
    REPLACE $zLim WITH $CR IN Text$
    zLabel = Text$
    hTooltip& = ToolTipData(0, 0)
    IF hTooltip& THEN

       ti.cbSize   = sizeof(ti)
       ti.hinst    = zInstance
       ti.uFlags   = %TTF_IDISHWND
       ti.hWnd     = GetParent(hObj&)
       ti.uId      = hObj&
       ti.lpszText = VARPTR(zLabel)
     ' Add tooltip now.
       CALL SendMessage(hTooltip&, %TTM_UPDATETIPTEXT, 0, BYVAL VARPTR(ti))
    END IF
END SUB

FUNCTION zStaticCenter(BYVAL Label$, BYVAL x&, BYVAL y&, BYVAL w&, BYVAL h&, BYVAL hParent&, BYVAL ID&) AS LONG
    hCtl& = CreateWindowEx(0, "STATIC", (Label$), %WS_CHILD OR %WS_VISIBLE OR %SS_CENTER, _
                           x&, y&, w&, h&, hParent&, ID&, zInstance, BYVAL %NULL)
    CALL zSetCTLFont(hCtl&, zDefaultFont)
    FUNCTION = hCtl&
END FUNCTION

FUNCTION WinMain (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL hMain       AS LONG
'
    LOCAl hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
'
    zClass = "ZOOMPLUS"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF
'
    IsInitialized& = GetClassInfoEx(zInstance, zClass, wc)
    IF IsInitialized&   = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_DBLCLKS OR %CS_HREDRAW OR %CS_VREDRAW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = 0
       wc.hInstance     = zInstance
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL ' GetStockObject(%BLACK_BRUSH)
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized& = %TRUE
    END IF
'
    IF IsInitialized& THEN

     ' ************************************************************************************
     ' Load the GDImage.dll
       IF RegisterGDImageClass() = 0 THEN
          FUNCTION = 99:  EXIT FUNCTION ' If it fails to register then return ERROR = 99
       END IF
     ' ************************************************************************************

     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
     ' Window Extended Style
       dwExStyle = %WS_EX_APPWINDOW OR %WS_EX_WINDOWEDGE
     ' Windows Style
       dwStyle = %WS_OVERLAPPEDWINDOW
'
       CALL SetRect(rc, 0, 0, 664, 482)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = "ZoomPlus GDImage " + ZI_Version
       hMain = CreateWindowEx(dwExStyle, _            ' Extended Style For The Window
                             zClass, _                ' Class Name
                             (MyTitle$), _            ' Window Title
                             dwStyle OR _             ' Defined Window Style
                             %WS_CLIPSIBLINGS OR _    ' Required Window Style
                             %WS_CLIPCHILDREN, _      ' Required Window Style
                             x, y, _                  ' Window Position
                             rc.nRight - rc.nLeft, _  ' Calculate Window Width
                             rc.nBottom - rc.nTop, _  ' Calculate Window Height
                             %NULL, _                 ' No Parent Window
                             %NULL, _                 ' No Menu
                             wc.hInstance, _          ' Instance
                             BYVAL %NULL)             ' Dont Pass Anything To WM_CREATE
'
       IF hMain THEN
'
        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(hMain, &H01 Or &H02 Or &H04 Or &H06)
          END IF
'
        ' ******************************************************************************
        ' Create the GDImage thumb control
        ' ------------------------------------------------------------------------------
          Style& = %WS_CHILD OR %WS_VISIBLE 'OR %WS_BORDER
          StyleEx& = %WS_EX_STATICEDGE
          CALL CreateWindowEx(StyleEx&, _
                             $GDImageClassName, _     ' GDImage class name
                             "", _                    ' Optional full path name to picture
                             Style&, _                ' window style
                             5, _                     ' initial x position
                             6, _                     ' initial y position
                             152, _                   ' Calculate Window Width
                             152, _                   ' Calculate Window Height
                             hMain, _                 ' parent window handle
                             %ID_THUMBCTRL, _         ' ControlID
                             zInstance, _             ' program instance handle
                             BYVAL 0)                 ' creation parameters
        ' This is a fit to window control
          CALL ZI_SetProperty(GetDlgItem(hMain, %ID_THUMBCTRL), %ZI_FitToWindow, 1)
        ' Associate an empty bitmap to it
          CALL ZI_SetCtrlEmptyBitmap(GetDlgItem(hMain, %ID_THUMBCTRL), %COLORGRAY)

        ' ******************************************************************************
        ' Create the zoom trackbar
        ' ------------------------------------------------------------------------------

          Style& = %WS_CHILD OR %WS_VISIBLE OR %TBS_BOTH OR %TBS_VERT OR %TBS_NOTICKS OR %WS_TABSTOP
          hCtrl& = CreateWindowEx(0, "msctls_trackbar32", "ZOOM", Style&, 168, 4, 16, 159, hMain, %ID_ZOOM, zInstance, BYVAL %NULL)
          CALL SendMessage(hCtrl&, %TBM_SETRANGE, %TRUE, MAKLNG(194,1020))
          CALL SendMessage(hCtrl&, %TBM_SETPAGESIZE, 0, 5)
        ' Setup zoom default
          CALL SendMessage(hCtrl&, %TBM_SETPOS, %TRUE, 195)
          Label$ = "Zoom"
          CALL zStaticCenter(Label$, 162, 163, 28, 16, hMain, %ID_STATIC)


        ' ******************************************************************************
        ' Create buttons
        ' ------------------------------------------------------------------------------
          CALL TB_InitXPButton() ' // Initialize Jos Roca TB_XPBUTTON control
          CALL CreateButton(17, 170, 40, 40, hMain, %ID_BTN_FlipX, _
                            LOADIMAGE(zInstance, "BTN_FlipX", %IMAGE_BITMAP, 0, 0, 0), _
                            "Flip left and right")
          CALL CreateButton(60, 170, 40, 40, hMain, %ID_BTN_Save, _
                            LOADIMAGE(zInstance, "BTN_Save", %IMAGE_BITMAP, 0, 0, 0), _
                            "Save image")
          CALL CreateButton(104, 170, 40, 40, hMain, %ID_BTN_FlipY, _
                            LOADIMAGE(zInstance, "BTN_FlipY", %IMAGE_BITMAP, 0, 0, 0), _
                            "Flip top and bottom")
          CALL CreateButton(17, 213, 40, 40, hMain, %ID_BTN_RotateLeft, _
                            LOADIMAGE(zInstance, "BTN_RotateLeft", %IMAGE_BITMAP, 0, 0, 0), _
                            "Rotate left")
          CALL CreateButton(60, 213, 40, 40, hMain, %ID_BTN_LoadImage, _
                            LOADIMAGE(zInstance, "BTN_LoadImage", %IMAGE_BITMAP, 0, 0, 0), _
                            "Load new image")
          CALL CreateButton(104, 213, 40, 40, hMain, %ID_BTN_RotateRight, _
                            LOADIMAGE(zInstance, "BTN_RotateRight", %IMAGE_BITMAP, 0, 0, 0), _
                            "Rotate right")
          CALL CreateButton(60, 299, 40, 40, hMain, %ID_BTN_CROP, _
                            LOADIMAGE(zInstance, "BTN_CROP", %IMAGE_BITMAP, 0, 0, 0), _
                            "Delimit rectangular section")

'
'        ' ******************************************************************************
'        ' Create static help comment
'        ' ------------------------------------------------------------------------------
'          Label$ = $CR + "Mouse use :" + $CR + $CR + "Left button" + $CR + "Zoom In." + $CR + $CR + _
'                   "Right button" + $CR + "Zoom Out." + $CR + $CR + "Image visibility is based on cursor location." + $CR + $CR + _
'                   "Zoom is proportional to mouse clic duration."
'          CALL CreateWindowEx(%WS_EX_TRANSPARENT, "STATIC", (Label$), %WS_CHILD OR %WS_VISIBLE OR %SS_CENTER, _
'                           5, 257, 152, 195, hMain, %ID_STA_Help, zInstance, BYVAL 0)
'          CALL zSetCTLFont(GetDlgItem(hMain, %ID_STA_Help), zCaptionFont)
'
'        ' Create help groupbox
'          CALL CreateWindowEx(%WS_EX_TRANSPARENT, _                             ' extended styles
'                              "Button", _                                       ' class name
'                              "", _                                             ' caption
'                              %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _ ' window styles
'                              %WS_GROUP OR _
'                              %BS_GROUPBOX, _                                   ' class styles
'                              5, 257, _                                         ' left, top
'                              152, 195, _                                       ' width, height
'                              hMain, %ID_GRP_Help, _                            ' handle of parent, control ID
'                              zInstance, BYVAL 0)                               ' handle of instance, creation parameters
'
        ' ******************************************************************************
        ' Create the main GDImage ZoomPlus control
        ' ------------------------------------------------------------------------------
          Style& = %WS_CHILD OR %WS_VISIBLE OR %WS_HSCROLL OR %WS_VSCROLL
          StyleEx& = %WS_EX_STATICEDGE
          hCtrl& = CreateWindowEx(StyleEx&, _          ' SDK extended style
                                $GDImageClassName, _   ' GDImage class name
                                "", _                  ' Optional full path name TO picture
                                Style&, _              ' window style
                                162 + 32, _                 ' initial x Position
                                6, _                   ' initial y Position
                                464, _                 ' Calculate Window Width
                                446, _                 ' Calculate Window Height
                                hMain, _               ' parent window Handle
                                %ID_CTRL, _            ' ControlID
                                zInstance, _           ' program Instance Handle
                                BYVAL 0)               ' creation parameters

          CALL ZI_SetProperty(hCtrl&, %ZI_GradientTop, %COLORGRAY)
          CALL ZI_SetProperty(hCtrl&, %ZI_GradientBottom, %COLORGRAY)

        ' Don't forget to make it a ZOOM window !
          CALL ZI_SetProperty(hCtrl&, %ZI_ZoomWindow, %TRUE)
        ' Set the correct anchor property
          CALL ZI_SetAnchorMode(hCtrl&, %ANCHOR_HEIGHT_WIDTH)
        ' Load default image
          CALL GDImageLoadFile(hMain, $FirstPicture)
        ' Create a %WM_RBUTTONDOWN event
          CALL ZI_EventMessage(CODEPTR(WndProc), %WM_RBUTTONDOWN, %TRUE)
'
        ' ******************************************************************************
        ' Create the status bar
        ' ------------------------------------------------------------------------------
          hStatus& = CreateWindowEx(0, _                               ' extended styles
                                 "msctls_statusbar32", _               ' class name
                                 "", _                                 ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR _         ' window styles
                                 %SBARS_TOOLTIPS OR %SBARS_SIZEGRIP, _ ' class styles
                                 0, 423, _                             ' left, top
                                 632, 23, _                            ' width, height
                                 hMain, %ID_STATUSBAR, _               ' handle of parent, control ID
                                 zInstance, BYVAL %NULL)               ' handle of instance, creation parameters

          CALL zSetCTLFont(hStatus&, zDefaultFont)

'
        ' Show the main window
          CALL ShowWindow(hMain, iCmdShow)
          CALL SetForegroundWindow(hMain)                  ' Slightly Higher Priority
          CALL SetFocus(hMain)                             ' Sets Keyboard Focus To The Window
'
          WHILE GetMessage(Msg, %NULL, 0, 0)
              IF IsDialogMessage(hMain, Msg) = %FALSE THEN
                 CALL TranslateMessage(msg)                ' Translate The Message
                 CALL DispatchMessage(msg)                 ' Dispatch The Message
              END IF
          WEND
          FUNCTION = msg.wParam
'
       END IF

     ' Delete the caption font
       CALL zDeleteObject(zCaptionFont)
'
     ' UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)
'
    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

SUB GDImageLoadFile(BYVAL hWnd AS LONG, BYVAL sFileName AS STRING)
    LOCAL rc AS RECT
    IF LEN(sFileName) THEN
       LOCAL xPicSize, yPicSize, hDCsrce, hDCdest, WasCursor AS LONG        

       WasCursor = SetCursor(LoadCursor(%NULL, BYVAL %IDC_WAIT))

       CALL ZI_SetFromFile(GetDlgItem(hWnd, %ID_CTRL), (sFileName))
       hDCsrce = ZI_GetDC(GetDlgItem(hWnd, %ID_CTRL))
       IF hDCsrce THEN
          CALL ZI_GetBitmapSize(ZI_GetBitmapFromDC(hDCsrce), xPicSize, yPicSize)
          hDCdest = ZI_GetDC(GetDlgItem(hWnd, %ID_THUMBCTRL))
          IF hDCdest THEN
             LOCAL xPos, yPos, xCell, yCell, xSize, ySize AS LONG
             CALL ZI_GetBitmapSize(ZI_GetBitmapFromDC(hDCdest), xCell, yCell)
             CALL ZD_FillRect(hDCdest, 0, 0, xCell, yCell, %COLORGRAY)
             CALL ZI_Iconise(xPicSize, yPicSize, xCell, yCell, xPos, yPos, xSize, ySize)
             CALL ZD_StretchBlt(hDCdest, xPos, yPos, xSize, ySize, hDCsrce, 0, 0, xPicSize, yPicSize)
           ' Refresh the %ID_THUMBCTRL display
             CALL ZI_UpdateWindow(GetDlgItem(hWnd, %ID_THUMBCTRL), 0)
          END IF
          ' Update trackbar bounds based on image size
          CALL GetClientRect(GetDlgItem(hWnd, %ID_CTRL), rc)
          CALL ZI_Iconise(xPicSize, yPicSize, rc.nRight, rc.nBottom, xP&, yP&, xS&, yS&)
          hCtrl& = GetDlgItem(hWnd, %ID_ZOOM)
          MinValue& = ((xS& - 24) / xPicSize) * 1000
          MaxValue& = 1000
          CALL SendMessage(hCtrl&, %TBM_SETRANGE, %TRUE, MAKLNG(MinValue&, MaxValue&))
          CALL SendMessage(hCtrl&, %TBM_SETPOS, %TRUE, MinValue&)
       END IF
       CALL SetCursor(WasCursor)
    END IF
END SUB

FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT
    LOCAL Orientation, Img, ImgW, ImgH, WasCursor AS LONG

    STATIC sFileName AS STRING

    SELECT CASE Msg

		CASE %WM_RBUTTONDOWN
			LOCAL lpr AS RECT, ZoomValue AS SINGLE, nW, nH, ZoomWidth, ZoomHeight, xOffset, yOffset, imgWidth, imgHeight AS LONG
			local xCurrentScroll as long, yCurrentScroll as LONG

			DP ("------------------------------------")
			DP ("lParam" + str$(LOWRD(lParam)) + ", " + str$(hiWRD(lParam)))

			x1& = LOWRD(lParam)
			y1& = hiWRD(lParam)

			' Get current Scroll values
			xCurrentScroll = ZI_GetXscroll(hWnd)
			yCurrentScroll = ZI_GetYscroll(hWnd)
			DP ("CurrentScroll " + str$(xCurrentScroll) + "," + str$(yCurrentScroll))

			' Get current Zoom value
			ZoomValue! = ZI_GetZoomValue(hWnd)
			DP ("ZoomValue " + str$(ZoomValue!))
			' Retrieve the size of the memory bitmap
			CALL ZI_GetImageSizeFromControl(hWnd, nW&, nH&)
			DP ("Imaze Size" + str$(nW&) + ", " + str$(nH&))
			' Get the client size of the control
			CALL GetClientRect(hWnd, lpr)
			DP ("lpr" + str$(lpr.nRight) + ", " + str$(lpr.nBottom))
			' Compute x,y offset
			ZoomWidth& = nW& * ZoomValue!
			ZoomHeight& = nH& * ZoomValue!
			DP ("Zoom W/H" + str$(ZoomWidth&) + ", " + str$(ZoomHeight&))
			xOffset& = 0: yOffset& = 0
			IF ZoomWidth& < lpr.nRight OR ZoomHeight& < lpr.nBottom THEN
				IF ZoomWidth& < lpr.nRight THEN xOffset& = (lpr.nRight - ZoomWidth&) \ 2
				IF ZoomHeight& < lpr.nBottom THEN yOffset& = (lpr.nBottom - ZoomHeight&) \ 2
			END IF
			DP ("Offsets" + str$(xOffset&) + ", " + str$(yOffset&))
			' Compute real coordinates
			IF ZoomValue! > 0 THEN
				 x1& = (x1& - xOffset& + xCurrentScroll) / ZoomValue!
				 y1& = (y1& - yOffset& + yCurrentScroll) / ZoomValue!
			END IF
			DP ("Zoomed Coords" + str$(x1&) + ", " + str$(y1&))
    CASE %WM_CREATE
         sFileName = $FirstPicture

    CASE %WM_GETMINMAXINFO 'Set minimum and naximum dialog size
         LOCAL MinMax AS MINMAXINFO PTR
         MinMax = lParam
       ' Window Extended Style
         dwExStyle& = %WS_EX_APPWINDOW OR %WS_EX_WINDOWEDGE
       ' Windows Style
         dwStyle& = %WS_OVERLAPPEDWINDOW
         CALL SetRect(rc, 0, 0, 632, 482)
         CALL AdjustWindowRectEx(rc, dwStyle&, %FALSE, dwExStyle&) ' Adjust Window To True Requested Size
         @MinMax.ptMinTrackSize.x = rc.nRight - rc.nLeft
         @MinMax.ptMinTrackSize.y = rc.nBottom - rc.nTop
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_CTLCOLORSTATIC
         IF lParam = GetDlgItem(hWnd, %ID_STA_Help) THEN
            CALL SetTextColor(wParam, RGB(2,77,220))
            CALL SetBkMode(wParam, %TRANSPARENT)
            FUNCTION = GetStockObject(%NULL_BRUSH)
            EXIT FUNCTION
         END IF

    CASE %WM_VSCROLL
         IF lParam = GetDlgItem(hWnd, %ID_ZOOM) THEN
            wP& = LOWRD(wParam)
            IF (wP& > %SB_LINEUP - 1) AND (wP& < %SB_ENDSCROLL + 1) THEN
                hCtrl& = GetDlgItem(hWnd, %ID_CTRL)
                NewPos& = SendMessage(GetDlgItem(hWnd, %ID_ZOOM), %TBM_GetPos, 0, 0)
                OldZoomValue! = ZI_GetZoomValue(hCtrl&)
                ZoomValue! = NewPos& / 1000
                CALL ZI_SetZoomValue(hCtrl&, ZoomValue!)
                CALL ZI_SetZoomScrollInfo(hCtrl&, OldZoomValue!, ZoomValue!)
                FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_COMMAND
         SELECT CASE LONG LOWRD(wParam)
         CASE %ID_CTRL
              SELECT CASE LONG HIWRD(wParam)
              CASE %ZM_Size
                 LOCAL sMessage AS STRING

								 CALL zSplitN(sFileName, "", sName$)
                 sMessage = sName$ + STR$(LOWRD(lParam)) + " x" + STR$(HIWRD(lParam))
                 CALL SetWindowText(GetDlgItem(hWnd, %ID_STATUSBAR), (sMessage))
              CASE %ZM_Crop
                 IF lParam = 1 THEN ' Selected
                    CALL ZI_GetCropCoordinates(x&, y&, UseWidth&, UseHeight&)

                    sMessage = "Cropped section" + STR$(x&)+","+str$(y&)+","+str$(UseWidth&)+","+str$(UseHeight&)
                    CALL SetWindowText(GetDlgItem(hWnd, %ID_STATUSBAR), (sMessage))

                    CropedBitmap& = ZI_CropWindowToBitmap(GetDlgItem(hWnd, %ID_CTRL), x&, y&, UseWidth&, UseHeight&)
                    IF ZI_PutBitmapToClipboard(CropedBitmap&) THEN

                       'SUCCESS
                       UseW& = UseWidth&  ' Use this to preserve the size of the picture
                       UseH& = UseHeight& ' Use this to preserve the size of the picture
                       Style& = %WS_POPUP OR %WS_BORDER OR %WS_VISIBLE OR %WS_CAPTION OR %WS_SYSMENU
                       StyleEx& = %WS_EX_TOOLWINDOW
                       CALL ZI_AdjustWindowRect(StyleEx&, UseW&, UseH&, Style&)
                       NewPopup& = CreateWindowEx(StyleEx&, _       ' Window extended style
                                          "ZIMAGECTRL", _            ' GDImage class name
                                          "", _         ' Optional full path name to picture
                                          Style&, _                  ' window style
                                          0, _                       ' initial x position
                                          0, _                       ' initial y position
                                          useW&, _                   ' Calculate Window Width
                                          useH&, _                   ' Calculate Window Height
                                          0, _                       ' Parent window handle
                                          0, _ ' <-------------------- Must be %NULL
                                          zInstance, _               ' program instance handle
                                          BYVAL 0)                   ' creation parameters
                       ' Copy clipboard to control (note: this also clears the clipboard)
                       IF NewPopup& THEN ZI_ClipboardPaste(NewPopup&)

                    ELSE
                       'ERROR
                    END IF
                 END IF
              END SELECT
         CASE %ID_BTN_FlipX
              IF LEN(sFileName) THEN
                 Orientation& = ZI_GetProperty(GetDlgItem(hWnd, %ID_CTRL), %ZI_Orientation)
                 IF Orientation = 4 THEN
                    Orientation = 0
                 ELSE
                    Orientation = 4
                 END IF
                 CALL ZI_SetProperty(GetDlgItem(hWnd, %ID_CTRL), %ZI_Orientation, Orientation)
                 CALL GDImageLoadFile(hWnd, sFileName)
              END IF
         CASE %ID_BTN_Save
              WasCursor = SetCursor(LoadCursor(%NULL, BYVAL %IDC_WAIT))
              Orientation = ZI_GetProperty(GetDlgItem(hWnd, %ID_CTRL), %ZI_Orientation)
              Img = zLoadImageFromFile((sFileName), imgW, imgH, Orientation)
              IF zSaveImageToFile((sFileName), Img, 0) = 0 THEN
                 ' SUCCESS
                 CALL ZI_SetProperty(GetDlgItem(hWnd, %ID_CTRL), %ZI_Orientation, 0)
                 CALL GDImageLoadFile(hWnd, sFileName)
              ELSE
                 ' ERROR
              END IF
              CALL SetCursor(WasCursor)
         CASE %ID_BTN_FlipY
              IF LEN(sFileName) THEN
                 Orientation = ZI_GetProperty(GetDlgItem(hWnd, %ID_CTRL), %ZI_Orientation)
                 IF Orientation = 6 THEN
                    Orientation = 0
                 ELSE
                    Orientation = 6
                 END IF
                 CALL ZI_SetProperty(GetDlgItem(hWnd, %ID_CTRL), %ZI_Orientation, Orientation&)
                 CALL GDImageLoadFile(hWnd, sFileName)
              END IF
         CASE %ID_BTN_RotateLeft
              IF LEN(sFileName) THEN
                 Orientation = ZI_GetProperty(GetDlgItem(hWnd, %ID_CTRL), %ZI_Orientation)
                 DECR Orientation
                 IF Orientation < 0 THEN Orientation = 3
                 CALL ZI_SetProperty(GetDlgItem(hWnd, %ID_CTRL), %ZI_Orientation, Orientation)
                 CALL GDImageLoadFile(hWnd, sFileName)
              END IF
         CASE %ID_BTN_LoadImage
              WasFileName$ = sFileName
              sFileName = ZI_LoadDialog(hWnd)
              CALL GDImageLoadFile(hWnd, sFileName)
            ' Check if they have canceled the load action
              IF LEN(sFileName) = 0 AND LEN(WasFileName$) THEN
                 sFileName = WasFileName$
              END IF
         CASE %ID_BTN_RotateRight
              IF LEN(sFileName) THEN
                 Orientation& = ZI_GetProperty(GetDlgItem(hWnd, %ID_CTRL), %ZI_Orientation)
                 INCR Orientation
                 IF Orientation > 3 THEN Orientation = 0
                 CALL ZI_SetProperty(GetDlgItem(hWnd, %ID_CTRL), %ZI_Orientation, Orientation)
                 CALL GDImageLoadFile(hWnd, sFileName)
              END IF
         CASE %ID_BTN_CROP
              CALL ZI_SetCropPopupText("Select,Cancel") ' The text of the popup contextual menu
              CALL ZI_EnableCropRectangle(GetDlgItem(hWnd, %ID_CTRL))
         END SELECT

'   CASE %WM_TIMER
		'CASE %WM_MOVING
    CASE %WM_SIZE
         IF wParam <> %SIZE_MINIMIZED THEN
            IF GetDlgItem(hWnd, %ID_STATUSBAR) THEN ' Move Status bar
               CALL SendMessage(GetDlgItem(hWnd, %ID_STATUSBAR), Msg, wParam, lParam)
            END IF
         END IF
    CASE %WM_ERASEBKGND
         CALL GetClientRect(hWnd, rc)
         CALL ZI_GradientPaintDC(wParam, 0, 0, rc.nRight, rc.nBottom, RGB(224,223,227), RGB(224,223,227))
         FUNCTION = 1: EXIT FUNCTION
'   CASE %WM_PAINT
'        FUNCTION = 0: EXIT FUNCTION
'   CASE %WM_CLOSE
    CASE %WM_DESTROY
         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION
    END SELECT
    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
END FUNCTION

SUB CreateButton(BYVAL x AS LONG, BYVAL y AS LONG, BYVAL w AS LONG, BYVAL h AS LONG, BYVAL hMain AS LONG, BYVAL ID AS LONG, BYVAL hImage AS LONG, BYVAL sTip AS STRING)
'   hBtn& = CreateWindowEx(0, "BUTTON", "", Style&, x, y, w, h, hMain, ID, zInstance, BYVAL 0)
'   hBmp(6) = LOADIMAGE(zInstance, "BTN_RotateRight", %IMAGE_BITMAP, 0, 0, 0)
'   CALL SendMessage(hBtn&, %BM_SETIMAGE, 0, hBmp(6))
'   CALL zToolTip(hBtn&, sTip)
    Style& =  %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR %WS_TABSTOP ' window styles
    hBtn& = CreateWindowEx(0, "TB_XPBUTTON", "", Style&, x, y, w, h, hMain, ID, zInstance, BYVAL 0)
    CALL TB_XPButton_SetImage (hBtn&, hImage, %IMAGE_BITMAP, %TB_XPBI_NORMAL, 0, %FALSE)
    CALL ZI_GetBitmapSize(hImage, w, h)
    CALL TB_XPButton_SetImageSize(hBtn&, w, h, 0)
    CALL TB_XPButton_SetImagePos (hBtn&, %TB_XPBI_CENTERCENTER, 0)
    CALL zToolTip(hBtn&, sTip)
END SUB
